---
title: 'ARIA: cell role'
slug: Web/Accessibility/ARIA/Roles/Cell_Role
tags:
  - ARIA
  - HTML
  - cell
  - table
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>The <code>cell</code> value of the ARIA <em>role</em> attribute identifies an element as being a cell in a tabular container that does not contain column or row header information. To be supported, the cell must be nested in an element with the role of <code>row</code>.</p>

<pre class="brush: html">&lt;div role="row"&gt;
  &lt;span role="cell"&gt;France&lt;/span&gt;
  &lt;span role="cell"&gt;67 million&lt;/span&gt;
&lt;/div&gt;
</pre>

<p>A better, more semantic way of writing the cells above would be to use the semantic <code><a href="/en-US/docs/Web/HTML/Element/td">&lt;td&gt;</a></code> element.</p>

<pre class="brush: html">&lt;tr role="row"&gt;
  &lt;td role="cell"&gt;France&lt;/td&gt;
  &lt;td role="cell"&gt;67 million&lt;/td&gt;
&lt;/tr&gt;
</pre>

<h2 id="Description">Description</h2>

<p>The element with <code>role="cell"</code> is a cell within a row, optionally within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a></code>, within a  <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a></code>, <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_Role">treegrid</a></code> within a static tabular structure. Using native <a href="/en-US/docs/Web/HTML/Element/td">HTML <code>&lt;td&gt;</code></a> elements, whenever possible, is strongly encouraged.</p>

<p>Each element with <code>role="cell"</code> MUST be nested in a container element with <code>role="row"</code>. That row, in turn, can be nested within an element with <code>role="rowgroup"</code>, and should be nested within a <code>grid</code>, <code>table</code> or <code>treegrid</code>. If a cell contains column or row header information, use the <code>colheader</code> or <code>rowheader</code> roles, respecitively. If the cell does not contain header information and is nested in a <code>grid</code> or <code>treegrid</code>, the role of <code>gridcell</code> may be more appropriate. </p>

<p>A cell can contain a number of property attributes clarifying the cell's position within the tabular data structure, including <code>aria-colindex</code>, <code>aria-colspan</code>, <code>aria-rowindex</code>, and <code>aria-rowspan</code>. </p>

<div class="note">
<p>Using the native HTML table element (&lt;table&gt;) along with the table row element (&lt;tr&gt;) and table cell element (&lt;td&gt;) whenever possible is strongly encouraged.</p>
</div>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<h4 id="Context_roles">Context roles</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">role="row"</a></dt>
 <dd>An element with <code>role="row"</code> is a row of cells within a tabular structure. A row contains one or more cells,  grid cells, column headers, or row headers within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a></code>, <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_Role" rel="nofollow">treegrid</a></code>, and optionally within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a></code>.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">role="rowgroup"</a></dt>
 <dd><code>Row</code> is a required cell parent. <code>Rowgroup</code> is an optional contextual row parent. It establishes a relationship between descendant rows. It is a structural equivalent to the <code><a href="/en-US/docs/Web/HTML/Element/thead">thead</a></code>, <code><a href="/en-US/docs/Web/HTML/Element/tfoot">tfoot</a></code>, and <code><a href="/en-US/docs/Web/HTML/Element/tbody">tbody</a></code> elements in an <a href="/en-US/docs/Learn/HTML/Tables/Basics">HTML <code>table</code></a> element.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">role="table"</a></dt>
 <dd>One of the three possible contexts (along with <code>grid</code> and <code>treegrid</code>) in which you'll find a row containing cells. Table identifies the cell as being part of a non-interactive table structure containing data arranged in rows and columns, similar to the native HTML <code><a href="/en-US/docs/Web/HTML/Element/table">&lt;table&gt;</a></code> element. </dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">role="grid"</a></dt>
 <dd>One of the three possible contexts (along with <code>table</code> and <code>treegrid</code>) in which you'll find a row containing <code>cells</code> and <code>gridcells</code>. <code>Grid</code> identifies a cell as being part of a possibly interactive table structure containing data arranged in rows and columns, similar to the native <code><a href="/en-US/docs/Web/HTML/Element/table">&lt;table&gt;</a></code> HTML element.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridtree_Role">role="treegrid"</a></dt>
 <dd>Similar to a grid, but with rows that can be expanded and collapsed in the same manner as for a tree.</dd>
</dl>

<h4 id="Subclass_roles">Subclass roles</h4>

<dl>
 <dt><a href="/en-US/docs/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">role="gridcell"</a></dt>
 <dd>A cell in a row within a <code>grid</code> or <code>treegrid.</code></dd>
 <dt>role="columnheader"</dt>
 <dd>A header cell that is the structural equivalent of the HTML <code><a href="/en-US/docs/Web/HTML/Element/th">&lt;th&gt;</a></code> element with a column scope. Unlike a plain cell, the <code>columnheader</code> role establishes a relationship between it and all cells in the corresponding column. </dd>
 <dt>role="rowheader"</dt>
 <dd>A header cell that is the structural equivalent of the HTML <code><a href="/en-US/docs/Web/HTML/Element/th">&lt;th&gt;</a></code> element with a row scope. Unlike a plain cell, the <code>rowheader</code> role establishes a relationship between it and all cells in the corresponding row. </dd>
</dl>

<h4 id="States_and_properties">States and properties</h4>

<dl>
 <dt>aria-colspan</dt>
 <dd>Similar to the HTML <code><a href="/en-US/docs/Web/HTML/Element/th">&lt;th&gt;</a></code> and <a href="/en-US/docs/Web/HTML/Element/td"><code>&lt;td&gt;</code> colspan attribute</a>, it defines the number of columns spanned by the cell.</dd>
 <dt>aria-rowspan</dt>
 <dd>Similar to the HTML <code><a href="/en-US/docs/Web/HTML/Element/th">&lt;th&gt;</a></code> and <a href="/en-US/docs/Web/HTML/Element/td"><code>&lt;td&gt;</code> rowspan attribute</a>, it defines the number of rows spanned by the cell.</dd>
 <dt>aria-colindex attribute</dt>
 <dd>
 <p>The <code>aria-colindex</code> attribute is only needed if columns are hidden from the DOM. The attribute takes as its value an integer between 1 and the total number of columns within the <code>table</code>, <code>grid</code> or <code>treegrid</code>. The <code>aria-colindex</code> defines an element's column index or position with respect to the total number of columns within a row. If all the columns are in the DOM, this attribute is not necessary.</p>
 </dd>
 <dt>aria-rowindex attribute</dt>
 <dd>
 <p>The <code>aria-rowindex</code> attribute is only needed if rows are hidden from the DOM, to indicate which row, in the list of total rows, the current cell is in. The attribute, takes as its value an integer between 1 and the total number of rows within the table, grid, or treegrid, indicating the position, or index, of the cell.  For example, a cell in the first row of the first header would likely have aria-rowindex="1" set, and cells in row 47 would have aria-rowindex="47", if aria-rowindex were needed due to not all rows being in the DOM. If the rows that are visible are contiguous, and there are no cells with a <code>colspan</code> or <code>rowspan</code> greater than one, this property can be added to the parent rows instead of all the rows' cells.</p>

  </dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>None</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>The first rule of ARIA use is if you can use a native feature with the semantics and behavior you require already built in, instead of repurposing an element and <strong>adding</strong> an ARIA role, state or property to make it accessible, then do so. Employ the HTML <code><a href="/en-US/docs/Web/HTML/Element/td">&lt;td&gt;</a></code> element instead of the ARIA role of <code>cell</code> whenever possible.</p>

<h2 id="Examples">Examples</h2>

<pre>&lt;div role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;div id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/div&gt;
  &lt;div role="rowgroup"&gt;
     &lt;div role="row"&gt;
       &lt;span role="columnheader" aria-sort="none" aria-rowindex="1"&gt;ARIA Role&lt;/span&gt;
       &lt;span role="columnheader" aria-sort="none" aria-rowindex="1"&gt;Semantic Element&lt;/span&gt;
     &lt;/div&gt;
   &lt;/div&gt;
   &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
       &lt;span role="cell" aria-rowindex="11"&gt;header&lt;/span&gt;
       &lt;span role="cell" aria-rowindex="11"&gt;h1&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"&gt;
      &lt;span role="cell" aria-rowindex="16"&gt;header&lt;/span&gt;
      &lt;span role="cell" aria-rowindex="16"&gt;h6&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"&gt;
      &lt;span role="cell" aria-rowindex="18"&gt;rowgroup&lt;/span&gt;
      &lt;span role="cell" aria-rowindex="18"&gt;thead&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"&gt;
      &lt;span role="cell" aria-rowindex="24"&gt;term&lt;/span&gt;
      &lt;span role="cell" aria-rowindex="24"&gt;dt&lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<p>The above is a non-semantic ARIA table with five of 81 rows present in the DOM: one within a table header and four rows within the table body. Because not all the rows are in the DOM, we've included the <code>aria-rowindex</code> property on every cell. If no cells spanned more than one row or column, the aria-rowindex could have been placed on the row rather than the row's individual cells.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Only use table, tbody, thead, tr, th, td, etc., for data table structure. You can add ARIA roles to ensure accessibility should the native semantics of the table be removed, such as with CSS. A relevant use case for the ARIA table role is when the native semantics of a table are overridden by <a href="/en-US/docs/Web/CSS/display#Accessibility_concerns">CSS's display property, such as by display: grid</a>. In this case, you can use the ARIA table roles to add the semantics back in.</p>

<pre>&lt;table role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;caption id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/caption&gt;
  &lt;thead role="rowgroup"&gt;
     &lt;tr role="row"&gt;
       &lt;th role="columnheader" aria-sort="none" aria-rowindex="1"&gt;ARIA Role&lt;/th&gt;
       &lt;th role="columnheader" aria-sort="none" aria-rowindex="1"&gt;Semantic Element&lt;/th&gt;
     &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody role="rowgroup"&gt;
     &lt;tr role="row"&gt;
       &lt;td role="cell" aria-rowindex="11"&gt;header&lt;/td&gt;
       &lt;td role="cell" aria-rowindex="11"&gt;h1&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row"&gt;
       &lt;td role="cell" aria-rowindex="16"&gt;header&lt;/td&gt;
       &lt;td role="cell" aria-rowindex="16"&gt;h6&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row"&gt;
       &lt;td role="cell" aria-rowindex="18"&gt;rowgroup&lt;/td&gt;
       &lt;td role="cell" aria-rowindex="18"&gt;thead&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row"&gt;
       &lt;td role="cell" aria-rowindex="24"&gt;term&lt;/td&gt;
       &lt;td role="cell" aria-rowindex="24"&gt;dt&lt;/td&gt;
     &lt;/tr&gt;
   &lt;/tbody&gt;
 &lt;/table&gt;</pre>

<p>Above is the semantic way of writing a table. The ARIA roles are not necessary if the native semantics of the table, and therefore the table rows, have not been altered, such as through <a href="/en-US/docs/Web/CSS/display#Accessibility_concerns">the display property</a>.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>none</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#cell","ARIA Cell Role")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#cell","ARIA Cell Role")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">role="gridcell"</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowheader_Role">role="rowheader"</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Colheader_Role">role="colheader"</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">role="row"</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/td">HTML&lt;td&gt; element</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/th">HTML &lt;th&gt; element </a></li>
 <li><a href="/en-US/docs/Learn/HTML/Tables/Advanced">HTML table advanced features and accessibility</a></li>
 <li><a href="/en-US/docs/Learn/HTML/Tables/Basics">HTML table basics</a></li>
</ul>
